class AVLDrevo{


  private AVLVozel koren;
  
   //konstruktor, ki ustvari prazno AVL drevo
   public AVLDrevo(){
   		this.koren = null;
   }

   //konstruktor, ki ustavri drevo z vozlom v
   public AVLDrevo(AVLVozel v){
      this.koren = v;
   }
   //metoda, ki ugotovi ali je drevo prazno
   public boolean prazno(){
      return this.koren == null;//vrne true ali false
   }
   
   /***********************************************************************/
   public AVLVozel koren(){
      return this.koren;//vrne koren drevesa
   }
   /**********************************************************************/


   //metoda vrne drevo
   public int vrni()throws Exception{
      if(!this.prazno()){ //ce ni prazno ga vrne
         return this.koren.vrniPodatek();
      }
      throw new Exception("Drevo je prazno! ");//drugace vrze izjemo
   }

   //metoda, ki vrne levega sina (levo poddrevo)
   public AVLDrevo leviSin(){
      AVLDrevo novo = new AVLDrevo();// ustvarimo novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnilevi();//koren levega postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }

   //metoda, ki vrne desnega sina (desno poddrevo)
   public AVLDrevo desniSin(){
      AVLDrevo novo = new AVLDrevo();// ustvarimo novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnidesni();//koren desnega postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }

   //metoda, ki vrne oeta
   public AVLDrevo oce(){
      AVLDrevo novo = new AVLDrevo();//novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnioce();//koren oceta postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }


//////////////////////// VSTAVI ////////////////////////////////
 	public void vstavi(int x){
		koren = vstavi(koren, x);
	}

    public AVLVozel vstavi(AVLVozel koren, int nPodatek){
        if(koren == null){
        	koren = new AVLVozel(nPodatek);
        }
        else{
            if(nPodatek < koren.vrniPodatek()){
               // nov AVLVozel v levo poddrevo
               AVLVozel tmp = vstavi(koren.vrnilevi(), nPodatek);
               //prestavimo kazalce
               koren.nastaviLevi(tmp);
               tmp.nastaviOce(koren);
               
               
            }
            else{
               // nov AVLVozel v desno poddrevo
               AVLVozel tmp = vstavi(koren.vrnidesni(),nPodatek);
               //prestavimo kazalce
               koren.nastaviDesni(tmp);
               tmp.nastaviOce(koren);
            }
        }
        
        //nastavimo faktor ravnotezja
        koren.nastaviFaktor(ravnotezje(koren));
        
        //preverimo faktorje ravnotezja
        // e je faktor ravnotezja manjsi od -1
		if(koren.vrniFaktor() < -1){
			//e je podatek veji od podatka v desnem sinu
			if(nPodatek > koren.vrnidesni().vrniPodatek()){  
			    // enojna rotacija v levo
				return levaRotacija(koren);
			}
			// dvojna rotacija
			else{  
			    //ce je podatek manjsi od podatka v desnem sinu
				if(nPodatek < koren.vrnidesni().vrniPodatek()){ 
					//rotacija v desno
					desnaRotacija(koren.vrnidesni());
				}
				//rotacija v levo
				return levaRotacija(koren);
			}
		}
		// e je faktor ravnotezja veji od 1
		else if(koren.vrniFaktor() > 1){
			//e je podatek manjsi od podatka v levem sinu
			if(nPodatek < koren.vrnilevi().vrniPodatek()){  
			    // enojna roracija v desno
				return desnaRotacija (koren);
			}
			// dvojna rotacija
			else{
				//e je podatek veji od podatka v levem sinu  
				if(nPodatek > koren.vrnilevi().vrniPodatek()){ 
					//rotacija v levo
					levaRotacija(koren.vrnilevi());
				}
				//rotacija v desno
				return desnaRotacija(koren);
			}
		}
		// na koncu vrnemo koren
        return koren;
    }
//////////////////////////////////////////////////////////////////////////////////////

    //metoda odstrani,ki iz iskalnega dvojiskega drevesa odstrani  element
    public void brisi(int nPodatek)throws Exception{
        koren = brisi(koren, nPodatek);
    }
    public AVLVozel brisi(AVLVozel koren, int nPodatek)throws Exception{
       if (koren == null){
          throw new Exception(" Drevo je prazno"); //ce je drevo prazno ne naredimo nic
       }
       else{
			if(nPodatek == koren.vrniPodatek()){ // nasli smo podatek
		    koren = izbrisiAVLVozel(koren);   // in ga zbrisemo
			
       }
       else if(nPodatek < koren.vrniPodatek()){ //podatek manjsi od korena
               // gremo rekurzivno v levo in primerjamo podatek
               koren.nastaviLevi(brisi(koren.vrnilevi(), nPodatek));
           }
           else{
			  // drugace gremo rekurzivno  v desno primerjamo podatek
              koren.nastaviDesni(brisi(koren.vrnidesni(), nPodatek));
           }
        }
        // nastavimo faktor ravnotezja v vozliscih
        koren.nastaviFaktor(ravnotezje(koren));
        
        // preverimo faktorje ravnotezja
		if(koren.vrniFaktor() < -1){
			if(nPodatek < koren.vrnidesni().vrniPodatek()){  // enojna rotacija v desno
				return levaRotacija(koren);
			}
			else{  // dvojna rotacija
				if(nPodatek < koren.vrnidesni().vrniPodatek()){ 
					desnaRotacija(koren.vrnidesni());
				}
				return levaRotacija(koren);
			}
		}
		else if(koren.vrniFaktor() > 1){
			if(nPodatek > koren.vrnilevi().vrniPodatek()){  // enojna roracija v levo
				return desnaRotacija (koren);
			}
			else{  // dvojna rotacija
				if(nPodatek > koren.vrnilevi().vrniPodatek()){ 
					levaRotacija(koren.vrnilevi());
				}
				return desnaRotacija(koren);
			}
		}
        return koren;
  }

    // metoda za brisanje vozla  iz drevesa
    private static AVLVozel izbrisiAVLVozel(AVLVozel koren) {
      if(koren.vrnilevi() == null){ // levega poddrevesa ni
      koren = koren.vrnidesni(); // nastavimo koren desnega poddrevesa
      }
      else if(koren.vrnidesni() == null) { //desnega poddrevesa ni
      koren = koren.vrnilevi(); // nastavimo koren levega poddrevesa
      }
      else{//imamo desno in levo poddrevo
         // poiscemo skrajno desni AVLVozel v levem poddrevesu,
         AVLVozel zadnji = poisciSkrajniDesni(koren.vrnilevi());
         //zamenjamo podatke
         koren.nastaviPodatek(zadnji.vrniPodatek());
         //zbrisemo skrajno levega
         koren.nastaviLevi(zbrisiSkrajniDesni(koren.vrnilevi()));
      }
      return koren;
    }

    //metoda,ki vrne skrajno levi AVLVozel
    private static AVLVozel poisciSkrajniDesni(AVLVozel koren) {
       if(koren.vrnidesni() != null) { //levo poddrevo ni prazno
         //vrne skrajno levega
         return poisciSkrajniDesni(koren.vrnidesni());
       }
       else {
		 //najmanjsi je kar koren
         return koren;
       }
    }
    // izbrisemo skrajni levi AVLVozel
    private static AVLVozel zbrisiSkrajniDesni(AVLVozel koren) {
       if(koren.vrnidesni() != null) { //levo poddrevo ni prazno
       	  //gremo v levo in ga zbrisemo
          koren.nastaviDesni(zbrisiSkrajniDesni(koren.vrnidesni()));
          return koren;
       }
       else{
		  //vrne koren desnega poddrevesa
          return koren.vrnilevi();
       }
   }
   //////////////////////////////////////////////////////////////////////
   
   
// desna rotacija
    public AVLVozel desnaRotacija(AVLVozel x) {
		// nastavimo trenutna vozlisca
		AVLVozel tmp = x.vrnioce();
		AVLVozel tmp1 = x;
		AVLVozel tmp2 = x.vrnilevi();
		// ce je oce razlicen od nic
		if(tmp != null)
			// ce je x levi sin
			if(tmp.vrnilevi() == tmp1)
				// potem ocetu nastavimo tmp2 za levega sina
				tmp.nastaviLevi(tmp2);
			else
				// drugae mu nastavimo tmp2 za desnega sina
				tmp.nastaviDesni(tmp2);
		// naredimo prevezavo vozlisc
		tmp2.nastaviOce(tmp);
		tmp1.nastaviLevi(tmp2.vrnidesni());
		tmp2.nastaviDesni(tmp1);
		tmp1.nastaviOce(tmp2);
		// dokler je tmp1 razlicen od nic
		while(tmp1 != null){
			// nastavimo faktor ravnotezja v vozliscu
			tmp1.nastaviFaktor(ravnotezje(tmp1));
			// pomaknemo se navzgoe proti korenu
			tmp1 = tmp1.vrnioce();

		}
		// kot rezultat vrnemo tmp2
		return tmp2;
    }

// leva rotacija
    public AVLVozel levaRotacija(AVLVozel x) {
		// nastavimo trenutna vozlisca
		AVLVozel tmp = x.vrnioce();
		AVLVozel tmp1 = x;
		AVLVozel tmp2 = x.vrnidesni();
		// ce je oce razlicen od nic
		if(tmp != null)
			// ce je x levi sin 
			if(tmp.vrnilevi() == tmp1)
				// potem ocetu nastavimo tmp2 za levega sina
				tmp.nastaviLevi(tmp2);
			else
				// drugace mu nastavimo tmp2 za desnega sina
				tmp.nastaviDesni(tmp2);
		// naredimo prevezave vozlisc
		tmp2.nastaviOce(tmp);
		tmp1.nastaviDesni(tmp2.vrnilevi());
		tmp2.nastaviLevi(tmp1);
		tmp1.nastaviOce(tmp2);
		// dokler tmp1 razlicen od nic
		while(tmp1 != null){
			// nastavimo faktor ravnotezja v vozliscu
			tmp1.nastaviFaktor(ravnotezje(tmp1));
			// pomaknemo se navzgor proti korenu
			tmp1 = tmp1.vrnioce();
		}
		// kot rezultat vrnemo tmp2
		return tmp2;

    }
    // metoda, ki izracuna faktor ravnotezja
	public int ravnotezje(AVLVozel v){
		// l in d sta na zacetku 0
		int l = 0;
		int d = 0;
		// ce je levo vozlisce razlicno od nic, potem je l visina levega + 1
		if(v.vrnilevi() != null) l = v.vrnilevi().visina() + 1;
		// ce je desno vozlisce razlicno od nic, potem je d visina desnega + 1
		if(v.vrnidesni() != null) d = v.vrnidesni().visina() + 1;
		// kot rzultat vrnemo njuno razliko
		return (l - d);
    }

	public static void main (String args[]) throws Exception{
		AVLDrevo b = new AVLDrevo ();
		
		
		Izpis.izpis(b,"");System.out.println ("\n------------- 12 ---------------\n");
		b.vstavi (12);
		Izpis.izpis(b,"");System.out.println ("\n------------- 13 ---------------\n");
		b.vstavi (13);
		Izpis.izpis(b,"");System.out.println ("\n------------- 14 ---------------\n");
		b.vstavi (14);
		Izpis.izpis(b,"");System.out.println ("\n------------- 5 ----------------\n");
		b.vstavi (5);
		Izpis.izpis(b,"");System.out.println ("\n------------- 3 ----------------\n");
		b.vstavi (3);
		Izpis.izpis(b,"");System.out.println ("\n------------- 11 ---------------\n");
		b.vstavi (11);
		Izpis.izpis(b,"");System.out.println ("\n------------- 6 ----------------\n");
		b.vstavi (6);
		Izpis.izpis(b,"");System.out.println ("\n------------- 10 ---------------\n");
		b.vstavi (10);
		Izpis.izpis(b,"");System.out.println ("\n------------- 8 ----------------\n");
		b.vstavi (8);
		
        
        Izpis.izpis(b,"");System.out.println ("\n--------- brisem 13 ------------\n");
		b.brisi (13);

		System.out.println ("\n------------ KONEC ----------------\n");
		Izpis.izpis(b,"");
        System.out.println ("\n------------ FAKTORJI ----------------\n");
        Izpis.izpisF(b,"");
	}
}





