// Razred AVLVozel 
//   * levi, desni (referenci na AVL naslednika);
//   * oce (referenca na oceta);
//   * faktor ( faktor ravnotezja v vozliscu)
// Vsebuje ustrezne konstruktorje in metode
// s kateri upravljamo z vozliscem

public class AVLVozel{

   private int podatek; 	// podatek, ki ga hranimo v vozliscu
   private int faktor = 0;  // faktor ravnotezja v vozliscu
   private AVLVozel levi;   // referenca na levi AVLVozel
   private AVLVozel desni;  // referenca na desni AVLVozel
   private AVLVozel oce;    // referenca na oceta
   
   // konstruktor, ki ustvari prazen vozel
   public AVLVozel(){
      this.podatek = 0;
      this.levi = null;
      this.desni = null;
      this.oce = null;
   }

   // AVL vozel s podatkom p
   public AVLVozel(int p){
      this.podatek = p;
      this.levi = null;
      this.desni = null;
      this.oce = null;
   }
   
   // AVL vozel s podatkom p in ocetom o
   public AVLVozel(int p,AVLVozel o){
      podatek = p;
      levi = null;
      desni = null;
      oce = o;
   }

   //vozel s podatkom p in kazalcema na levega (l)
   // in desnega (d) naslednika
   public AVLVozel(int p, AVLVozel l, AVLVozel d){
      this.podatek = p;
      this.levi = l;
      this.desni = d;
      this.oce = null;// oceta nastavljamo sproti
   }

   //metoda, ki nastavi podatel v vozlu
   public void nastaviPodatek(int x){
      this.podatek = x;
   }

  //metoda, ki vrne podatek v vozlu
   public int vrniPodatek(){
      return this.podatek;
   }

   //metoda, ki nastavi levega naslednika
   public void nastaviLevi(AVLVozel v){
      this.levi = v;
   }

   //metoda, ki vrne levega naslednika
   public AVLVozel vrnilevi(){
      return this.levi;
   }

   //metoda, ki nastavi desnega naslednika
   public void nastaviDesni(AVLVozel v){
      this.desni = v;
   }

   //metoda, ki vrne desnega naslednika
   public AVLVozel vrnidesni(){
      return this.desni;
   }

   //metoda, ki nastavi oceta
   public void nastaviOce(AVLVozel v){
      this.oce = v;
   }

   //metoda, ki vrne oceta
   public AVLVozel vrnioce(){
      return this.oce;
   }
 
   
   //metoda, ki nastavi faktor ravnotezja v vozliscu
   public void nastaviFaktor(int x){
      this.faktor = x;
   }

   //metoda, ki vrne faktor ravnotezja v vozliscu
   public int vrniFaktor(){
      return this.faktor;
   }
 
   //metoda visina, ki nastavi visino vozlisca
   public int visina(){
   	  if(this.vrnidesni() != null || this.vrnilevi() != null ){ 
        int l = (this.vrnilevi()!= null)?(1 + this.vrnilevi().visina()):0;
        int d = (this.vrnidesni()!= null)?(1 + this.vrnidesni().visina()):0;
        return  Math.max(l, d);
   	  }
   	  else
   	  	return 0;
   	} 
   	 
}








