// Razred RCDVozel
//   * levi, desni (referenci na RCD naslednika);
//   * oce (referenca na oceta);
//   * faktor ( faktor ravnotezja v vozliscu)
// Vsebuje ustrezne konstruktorje in metode
// s kateri upravljamo z vozliscem

public class RCDVozel{

   private int podatek; 	// podatek, ki hranimo v vozliscu
   private boolean rdece = true;  // barva vozlisc za RC drevo
   private RCDVozel levi;   // referenca na levi RCDVozel
   private RCDVozel desni;  // referenca na desni RCDVozel
   private RCDVozel oce;    // referenca na oceta
   
   // konstruktor, ki ustvari prazen vozel
   public RCDVozel(){
      this.podatek = 0;
      this.levi = null;
      this.desni = null;
      this.oce = null;
   }

   // RCD vozel s podatkom p
   public RCDVozel(int p){
      this.podatek = p;
      this.levi = null;
      this.desni = null;
      this.oce = null;
   }
   
   // RCD vozel s podatkom p in ocetom o
   public RCDVozel(int p,RCDVozel o){
      podatek = p;
      levi = null;
      desni = null;
      oce = o;
   }

   //vozel s podatkom p in kazalcema na levega (l)
   // in desnega (d) naslednika
   public RCDVozel(int p, RCDVozel l, RCDVozel d){
      this.podatek = p;
      this.levi = l;
      this.desni = d;
      this.oce = null;// oceta nastavljamo sproti
   }

   //metoda, ki nastavi podatel v vozlu
   public void nastaviPodatek(int x){
      this.podatek = x;
   }

  //metoda, ki vrne podatek v vozlu
   public int vrniPodatek(){
      return this.podatek;
   }

   //metoda, ki nastavi levega naslednika
   public void nastaviLevi(RCDVozel v){
      this.levi = v;
   }

   //metoda, ki vrne levega naslednika
   public RCDVozel vrnilevi(){
      return this.levi;
   }

   //metoda, ki nastavi desnega naslednika
   public void nastaviDesni(RCDVozel v){
      this.desni = v;
   }

   //metoda, ki vrne desnega naslednika
   public RCDVozel vrnidesni(){
      return this.desni;
   }

   //metoda, ki nastavi oceta
   public void nastaviOce(RCDVozel v){
      this.oce = v;
   }

   //metoda, ki vrne oceta
   public RCDVozel vrnioce(){
      return this.oce;
   }
 
   //metoda, ki nastavi barvo v vozlu na true, ce je rdec, sicer false
   public void nastaviRdec(boolean rdece){
      this.rdece = rdece;
   }

   //metoda, ki vrne true, ce je vozlisce rdece sicer false
   public boolean rdec(){
      return this.rdece;
   }	 
}








