/*
 * Rdece crno drevo
 *
 */

 public class RCDrevo{

  private RCDVozel koren;
  
   //konstruktor, ki ustvari prazno RCD drevo
   public RCDrevo(){
   		this.koren = null;
   }

   //konstruktor, ki ustavri drevo z vozlom v
   public RCDrevo(RCDVozel v){
      this.koren = v;
   }
   //metoda, ki ugotovi ali je drevo prazno
   public boolean prazno(){
      return this.koren == null;//vrne true ali false
   }
   
   /***********************************************************************/
   public RCDVozel koren(){
      return this.koren;//vrne koren drevesa
   }
   /**********************************************************************/


   //metoda vrne drevo
   public int vrni()throws Exception{
      if(!this.prazno()){ //ce ni prazno ga vrne
         return this.koren.vrniPodatek();
      }
      throw new Exception("Drevo je prazno! ");//drugace vrze izjemo
   }

   //metoda, ki vrne levega sina (levo poddrevo)
   public RCDrevo leviSin(){
      RCDrevo novo = new RCDrevo();// ustvarimo novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnilevi();//koren levega postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }

   //metoda, ki vrne desnega sina (desno poddrevo)
   public RCDrevo desniSin(){
      RCDrevo novo = new RCDrevo();// ustvarimo novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnidesni();//koren desnega postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }

   //metoda, ki vrne oeta
   public RCDrevo oce(){
      RCDrevo novo = new RCDrevo();//novo prazno drevo
      if(!this.prazno()){// ce ni prazno
         novo.koren = this.koren.vrnioce();//koren oceta postane koren novega
      }
      return novo;//drugace vrne novo prazno drevo
   }
/*
 *
 VSTAVI
 *
 *
 */
	// metoda vstavi, ki vstavi podatek v RCD
	public void vstavi(int z)throws Exception{
		// ustvarimo pomozne RCDVozle za pomoc
		RCDVozel y = null;
		RCDVozel x = koren;
		// ali je vstavljeno vozlisce levi sin
		boolean levi = false;
		// dokler ne bomo prisli do korena - trenutno vozlisce x ne obstaja vec
		while(x != null){
			y = x;
			// ce podatek z spada v levo poddrevo
			if(z < x.vrniPodatek()){
				// gremo v levo
				x = x.vrnilevi();
				levi = true;
			}
			else{
				// drugace gremo v desno
				x = x.vrnidesni();
				levi = false;
			}
		}
		//ko najdemo pravo mesto, naredimo nov RCDVozel s podatkom z
		RCDVozel pom = new RCDVozel(z);
		// in kazalcem na oceta y
		pom.nastaviOce(y);
	
		// v drevo smo vstavili prvi podatek 
		if(y == null){
			koren = new RCDVozel(z);
		}
		else if(levi == true) y.nastaviLevi(pom);
		else y.nastaviDesni(pom);
		//in ga obarvamo rdece
		pom.nastaviRdec(true);
		//ter preverimo barve po vstavljanju
		preveriBarve_poVstavljanju(pom);
	}

/*
 *
 ODSTRANI
 *
 *
 */
 	// metoda odstrani, ki odstrani podatek iz RCD
	public RCDVozel odstrani(int x){
		 // poiscemo vozlisce, ki vsebuje podatek x
		 RCDVozel pom = poisci(x);
		 // ce je vozlisce razlicno od null, potem ga izbrisemo iz drevesa
	   if(pom != null) return odstrani(pom);
	   return koren;
	}
	
	// metoda, ki poisce podatek ki ga zelimo brisati
	public RCDVozel poisci(int x){
		 // poiscemo vozlisce, ki vsebuje podatek x
		 // pomozni kazalec na trenutno vozlisce
		 RCDVozel pom = koren; 
		 while(pom != null){ // ponavljamo dokler ce moremo
		  	if(pom.vrniPodatek() == x) return pom; // nasli smo vozlisce s podatkom x
		  	if(pom.vrniPodatek() < x) pom = pom.vrnidesni(); // gremo v desno
		  	else pom = pom.vrnilevi();// gremo v levo
		}
		// nismo nasli vozlisca, zato vrnemo null
		return null; 
	}
	
	// metoda, ki odstrani vozlisce
	public RCDVozel odstrani(RCDVozel z) throws NullPointerException{
	    // ustvarimo nova prazna  vozlisca
	    RCDVozel x = new RCDVozel();
	    RCDVozel y = new RCDVozel();
	    //za pomoc si ustvarimo tudi strazarja
		RCDVozel strazar = new RCDVozel();
		// in mu nastavimo barvo na crno
		strazar.nastaviRdec(false);
		
		// z ima vsaj enega sina enakega null
		if (z.vrnilevi() == null || z.vrnidesni() == null){
			y = z;
		}
		else{
			// y je naslednik z-ja 
			y = naslednik(z);
		}
		//x je y-ov edini sin
		if (y.vrnilevi() != null){
			// y ima levega sina
			x = y.vrnilevi();
		}
		else{
			// x je y-ov edini sin
			if (y.vrnidesni() != null){
				// y ima desnega sina 
				x = y.vrnidesni();
			}
			else{
				// y nima nobenega od sinov
				// zato mu nastavimo strazarja
				x = strazar;
			}
		}
		// x-u nastavimo y-ovega bivsega oceta 
		x.nastaviOce(y.vrnioce());
		
		// ce je y koren
		if (y.vrnioce() == null){
			// potem je x koren 
			this.koren = x;
		}
		
		else{ // prikljuci oceta k svojima novima sinovoma 
		      // kot levi ali desni sin
			if (y == y.vrnioce().vrnilevi()){ // ce je y levi sin svojega oceta
				y.vrnioce().nastaviLevi(x); // potem tudi x levi sin y-ovega oceta
				// x-u nastavimo se y-ov podatek
				x.nastaviPodatek(y.vrniPodatek());
				
			}
			else{
				// drugace je x desni sin y-ovega oceta
				y.vrnioce().nastaviDesni(x);
			}
		}
		// ce je y razlicen od z
		if 	(y != z){
			// z-ju nastavimo y-ov podatek 
			z.nastaviPodatek(y.vrniPodatek());
		}
		// ce je y crne barve
		if (!y.rdec()){
			// preverimo barve po brisanju
			preveriBarve_poBrisanju(x);
		}
    	// odstranimo vse reference do strazarja
		// drugace je strazar lahko viden v drevesu
		if (this.koren != strazar ){
			if (strazar != null && (strazar.vrnioce()).vrnilevi() == strazar){
				strazar.vrnioce().nastaviLevi(null);
		    }
            if (strazar != null && (strazar.vrnioce()).vrnidesni() == strazar){
				strazar.vrnioce().nastaviDesni(null);
		    }
			strazar = null;
		}
		else{
			this.koren = null;
			strazar = null;
		}
		return y;
	}
	
//////////////////////////////////////////////////
//  NASLEDNIK  //
//metoda, ki vrne naslednika vozlisca x
   public static RCDVozel naslednik(RCDVozel x){
	    RCDVozel y = null;
	    if(x.vrnilevi() != null){
	       return najvecji(x.vrnilevi());
         }
         y.nastaviOce(x.vrnioce());
         while(y != null && x == y.vrnilevi()){
			 x = y;
			 y = y.vrnioce();
		 }
   return y;
}

// NAJVECJI //
// metoda, ki v iskalnem dvojiskem drevesu poisce najvecji element
    public static RCDVozel najvecji(RCDVozel x){
		while(x.vrnidesni() != null){
			x = x.vrnidesni();
		}
		return x;
   }   
   
// leva rotacija
	public RCDVozel levaRotacija(RCDVozel x){
		// y je x-ov desni sin
		RCDVozel y = x.vrnidesni();
		// x-u nastavimo desnega sina 
		x.nastaviDesni(y.vrnilevi());
		// ce je y-ov levi sin razlicen od null
		if(y.vrnilevi() != null){
			// y-ovemu levemu sinu nastavimo za oceta vozlisce x
			y.vrnilevi().nastaviOce(x);
		}
		// y-u nastavimo x-ovega oceta
		y.nastaviOce(x.vrnioce());
	
		//ce x ima oceta	
		if(x.vrnioce()!= null){
			// in ce je x levi sin svojega oceta
			if(x == x.vrnioce().vrnilevi()){
				//potem x-ovemu ocetu nastavimo y za levega sina
				x.vrnioce().nastaviLevi(y);
			}
			else{
				// drugace mu nastavimo y za desnega sina
				x.vrnioce().nastaviDesni(y);
		    }
		}
		else {
			// drugace je y koren
			koren = y;
		}
		
		//y-u nastavimo x za levega sina
		y.nastaviLevi(x);
		// x-ov za oceta nastavimo y
		x.nastaviOce(y);

		// vrnemo y
		return y;
	}
	
// desna rotacija
	public RCDVozel desnaRotacija(RCDVozel x){
		// y je x-ov levi sin
		RCDVozel y = x.vrnilevi();
		// x-u nastavimo levega sina
		x.nastaviLevi(y.vrnidesni());
		// ce je y-ov desni sin razlicen od null
		if(y.vrnidesni() != null){
			// y-ovemu desnemu sinu  nastavimo za oceta vozlisce x
			y.vrnidesni().nastaviOce(x);
		}
		// y-u nastavimo x-ovega oceta
		y.nastaviOce(x.vrnioce());

		//ce je oce x-a razlicen od null
		if(x.vrnioce()!= null){
			// in ce je x desni sin svojega oceta
			if(x == x.vrnioce().vrnidesni()){
				//potem x-ovemu ocetu nastavimo y za desnega sina
				x.vrnioce().nastaviDesni(y);
			}
			else{
				// drugace mu nastavimo y za levega sina
				x.vrnioce().nastaviLevi(y);
			}	
		}
		else{
			// drugace je y koren
			koren = y;
		}
		//y-u nastavimo x za desnega sina
		y.nastaviDesni(x);
		// x dobi y za oceta 
		x.nastaviOce(y);

		// vrnemo y
		return y;
	}
   
   // metoda, ki poskrbi za pravilnost rdece-crnega drevesa 
   // po vstavljanju podatka v rdece-crno drevo
   public void preveriBarve_poVstavljanju(RCDVozel r)throws Exception{
      //oce obstaja in je rdece barve
      while(r.vrnioce() != null && r.vrnioce().rdec()){
      	 // r-jev oce je levi sin 
         if(r.vrnioce() == r.vrnioce().vrnioce().vrnilevi()){
               //smo na levi strani, y je r-jev stric
               RCDVozel y = r.vrnioce().vrnioce().vrnidesni();
               //ce je y razlicen od null in je rdec
               if(y != null && y.rdec()){
                  //sledi prebarvanje oceta in strica
                  //oceta obarvamo crno
                  r.vrnioce().nastaviRdec(false);
                  //strica obarvamo crno
                  y.nastaviRdec(false);
                  //starega oceta obarvamo na rdece
                  r.vrnioce().vrnioce().nastaviRdec(true);
                  //stari oce postane trenutno vozlisce
                  r = r.vrnioce().vrnioce();
               }
               // ce je y crn oz. y-a ni
               else{
               	  // ce je r desni sin 
                  if(r == r.vrnioce().vrnidesni()){
                  	 // zaradi rotacije trenutno vozlisce postane oce
                     r = r.vrnioce();
                     // izvedemo levo rotacijo
                     levaRotacija(r);
                  }
                  // oce postane crn
                  r.vrnioce().nastaviRdec(false);
                  // stari oce rdec
                  r.vrnioce().vrnioce().nastaviRdec(true);
                  //  rotiramo desno okoli starega oceta
                  desnaRotacija(r.vrnioce().vrnioce());
               }
         }
         // drugace simetricen primer
         else {
         	// smo na desni strani in y je r-jev stric
            RCDVozel y = r.vrnioce().vrnioce().vrnilevi();
            //ce je y razlicen od null in je rdec
            if(y != null && y.rdec()){
               //sledi prebarvanje oceta in strica
               //oceta obarvamo crno
               r.vrnioce().nastaviRdec(false);
               //strica obarvamo crno
               y.nastaviRdec(false);
               //starega oceta obarvamo rdece
               r.vrnioce().vrnioce().nastaviRdec(true);
               //stari oce postane trenutno vozlisce
               r = r.vrnioce().vrnioce();
            } 
            // ce je y crn oz. y-a ni
            else{
               // ce je r levi sin 
               if(r == r.vrnioce().vrnilevi()){
               	  // oce postane trenutno vozlisce
                  r = r.vrnioce();
                  // izvedemo desno rotacijo
                  desnaRotacija(r);
               }
               // oceta obarvamo crno
               r.vrnioce().nastaviRdec(false);
               // starega oceta obarvamo rdece
               r.vrnioce().vrnioce().nastaviRdec(true);
               // in izvedemo desno rotacijo na starem ocetu
               levaRotacija(r.vrnioce().vrnioce());
            }
         }

      }
      // na koncu koren drevesa obarvamo crno
      this.koren.nastaviRdec(false);
   }
   
	public void preveriBarve_poBrisanju(RCDVozel b){
		RCDVozel w = new RCDVozel();
		// dokler b crn
		while(b != this.koren && !b.rdec()){
			// b je levi sin
			if (b == (b.vrnioce()).vrnilevi()){
				// w je desni sin ali b-jev brat
			 	w = (b.vrnioce()).vrnidesni(); 
			 	// ce je brat rdec
				if (w.rdec()){
					// obarvamo w crno
					w.nastaviRdec(false);
					// oceta obarvamo rdece
					(b.vrnioce()).nastaviRdec(true);
					// rotiramo v levo okoli oceta
					levaRotacija(b.vrnioce());
					// w je desni sin
					w = (b.vrnioce()).vrnidesni();
				}
				// ce sta oba sinova crna
				if ( w.vrnidesni() != null && w.vrnilevi() != null
					  && !w.vrnidesni().rdec() && !w.vrnilevi().rdec())
					
				{
					// w obarvamo rdece
					w.nastaviRdec(true);
					// oce postane trenutno vozlisce
					b = b.vrnioce();
				}
				else{
					// ce je desni sin crne barve
					if ( w.vrnidesni() != null && !w.vrnidesni().rdec()){
						// levega obarvamo crno
						(w.vrnilevi()).nastaviRdec(false);
						//w obarvamo rdece
						w.nastaviRdec(true);
						// rotiramo v desno okoli w
						desnaRotacija(w);
						// w postane trenutno vozlisce
						w = (b.vrnioce()).vrnidesni();
					}
					// ce je oce crn
					if (!b.vrnioce().rdec()){
						// w obarvamo crno
						w.nastaviRdec(false);
					}
					else{
						// drugace w obarvamo rdece
						w.nastaviRdec(true);
					}
					// oceta obarvamo crno
					(b.vrnioce()).nastaviRdec(false);
					// desni sin obstaja
					if (w.vrnidesni() != null){ 
					  //ga obarvamo crno
					  (w.vrnidesni()).nastaviRdec(false);
				    }
				    // rotiramo v levo okoli oceta
					levaRotacija(b.vrnioce());
					// koren postane trenutno vozlisce
					b = this.koren;
				}
			}
			else{
				// w je levi sin
				w = (b.vrnioce()).vrnilevi(); 
				// ce je w rdec
				if (w.rdec()){
					// ga obarvamo crno
					w.nastaviRdec(false);
					// oceta obarvamo rdece
					(b.vrnioce()).nastaviRdec(true);
					// rotiramo v desno okoli oceta
					desnaRotacija(b.vrnioce());
					// levi sin b-ja postane trenutno vozlisce
					w = (b.vrnioce()).vrnilevi();
				}
				if (w.vrnidesni() != null && w.vrnilevi() != null
					  && !w.vrnidesni().rdec() && !w.vrnilevi().rdec())
				{
					// w obarvamo rdece
					w.nastaviRdec(true);
					// oce postane trenutno vozlisce
					b = b.vrnioce();
				}
				else{
					// ce je levi razlicen od nic in je crne barve
					if ( w.vrnilevi() != null && (w.vrnilevi()).rdec()==false){
						// desnega obarvamo crno
						(w.vrnidesni()).nastaviRdec(false);
						// w obarvamo rdece
						w.nastaviRdec(true);
						// rotiramo v levo okoli w
						levaRotacija(w);
						// levi sin b-ja postane trenutno vozlisce
						w = (b.vrnioce()).vrnilevi();
					}
					// ce je oce crn
					if (!b.vrnioce().rdec()){
						// w obarvamo crno
						w.nastaviRdec(false);
					}
					else{
						// drugace ga obarvamo rdece
						w.nastaviRdec(true);
					}
					// oceta obarvamo crno
					(b.vrnioce()).nastaviRdec(false);
					if (w.vrnilevi() != null){  
					  // drugace je crn
					  (w.vrnilevi()).nastaviRdec(false);
				    }
				    // rotiramo v desno okoli oceta
					desnaRotacija(b.vrnioce());
					//koren postane trenutno vozlisce
					b = this.koren;
				}
			}
		} 
		// obarvamo ga crno
		b.nastaviRdec(false);
	} 	


  public static void main (String args[]) throws Exception{
  
    RCDrevo b = new RCDrevo();
    
    Izpis.izpis(b,"");System.out.println ("\n--------------- 12 ----------------\n");
    b.vstavi (12);
    
    Izpis.izpis(b,"");System.out.println ("\n--------------- 13 ----------------\n");
    b.vstavi (13);
    
	Izpis.izpis(b,"");System.out.println ("\n--------------- 14 ----------------\n"); 
	b.vstavi (14);

    Izpis.izpis(b,"");System.out.println ("\n---------------- 5 ------------------\n");
    b.vstavi (5);
    
    Izpis.izpis(b,"");System.out.println ("\n----------------- 3 -----------------\n");
    b.vstavi (3);
    
    Izpis.izpis(b,"");System.out.println ("\n-------------- 11 -----------------\n");
    b.vstavi (11);

    Izpis.izpis(b,"");System.out.println ("\n-------------- 6 -----------------\n");
    b.vstavi (6);
    
    Izpis.izpis(b,"");System.out.println ("\n-------------- 10 -----------------\n");
    b.vstavi (10);
    
    Izpis.izpis(b,"");System.out.println ("\n-------------- 8 -----------------\n");
    b.vstavi (8);
    
    Izpis.izpisB(b,"");System.out.println ("\n----------------------------------\n");

    System.out.println ("\n------------ ---- ----------------\n");
    
    b.odstrani(3);
    Izpis.izpisB(b,"");System.out.println ("\n----------------------------------\n");
    Izpis.izpis(b,"");
    b.odstrani (13);
    Izpis.izpisB(b,"");System.out.println ("\n----------------------------------\n");
    Izpis.izpis(b,"");
    b.odstrani (11);
    System.out.println ("\n------------ KONEC - THE END----------------\n");
    Izpis.izpis(b,"");
    System.out.println ("\n------------ BARVE ----------------\n");
    Izpis.izpisB(b,"");
  }
 }